<cfset request.dsn = "barneyb" />
<cfset request.tablename = "treedemo" />

<!--- you should initialize this once and cache it somewhere, rather than loading it every request --->
<cfset tm = createObject("component", "treemanager").init(
	request.dsn,
	request.tablename,
	"name",
	"lpos",
	"rpos",
	"id"
) />

<cfparam name="url.do" default="" />

<cfswitch expression="#url.do#">

	<cfcase value="install">
		<cfquery datasource="#request.dsn#" name="">
			CREATE TABLE #request.tablename# (
				id INT UNSIGNED NOT NULL PRIMARY KEY,
				lpos INT UNSIGNED,
				rpos INT UNSIGNED,
				name VARCHAR(50) NOT NULL
			)
		</cfquery>
		<cfquery datasource="#request.dsn#" name="">
			INSERT INTO treedemo
				(id, name
				)
			VALUES
				( 1, "lindsay"),

				( 2, "heather"),
				( 3, "barney"),

				( 4, "gail"),
				( 5, "christian"),
				( 6, "dolores"),
				( 7, "gerald"),

				( 8, "gwynneth"),
				( 9, "cedric"),
				(10, "francis"),
				(11, "kathryn"),
				(12, "cortlandt"),
				(13, "burnadette"),
				(14, "wilfred")
		</cfquery>
		<cfscript>
			tm.initializeHierarchy(1);
			tm.injectIntoHierarchy(2, 1);
			tm.injectIntoHierarchy(3, 1);
			tm.injectIntoHierarchy(4, 2);
			tm.injectIntoHierarchy(5, 2);
			tm.injectIntoHierarchy(6, 3);
			tm.injectIntoHierarchy(7, 3);
			tm.injectIntoHierarchy(8, 4);
			tm.injectIntoHierarchy(9, 4);
			tm.injectIntoHierarchy(10, 5); // only one parent for christian
			tm.injectIntoHierarchy(11, 6);
			tm.injectIntoHierarchy(12, 6);
			tm.injectIntoHierarchy(13, 7);
			tm.injectIntoHierarchy(14, 7);
		</cfscript>
		<cflocation url="#listLast(cgi.script_name, "/")#?do=view" addtoken="false" />
	</cfcase>
	
	<cfcase value="view">
		<cfset nodes = tm.getNodeList("*") />
		<cfoutput>
		<style type="text/css">
			.number {
				text-align: right;
				font-family: monospace;
				font-size: 1em;
			}
			.alt1 { background-color: inherit; }
			.alt0 { background-color: ##f7f7ff; }
			table {
				border-top: 1px solid ##ccc;
				border-left: 1px solid ##ccc;
			}
			td, th {
				border-right: 1px solid ##ccc;
				border-bottom: 1px solid ##ccc;
				padding: 2px 4px;
				font-family: verdana,sans-serif;
				font-size: 0.75em;
			}
			th {
				text-align: left;
				font-weight: bold;
				background-color: ##ccf;
			}
		</style>
		<a href="#listLast(cgi.script_name, "/")#">Home</a>
		<table cellspacing="0">
		<tr>
			<th>name</th>
			<th>id</th>
			<th>depth</th>
			<th>lpos</th>
			<th>rpos</th>
		</tr>
		<cfloop query="nodes">
			<tr class="alt#currentRow MOD 2#">
				<td nowrap="nowrap">#repeatString("&nbsp; ", depth - 1)##name#</td>
				<td class="number">#id#</td>
				<td class="number">#depth#</td>
				<td class="number">#lpos#</td>
				<td class="number">#rpos#</td>
			</tr>
		</cfloop>
		</table>
		</cfoutput>
	</cfcase>
	
	<cfdefaultcase>
		<cfoutput>
		<style type="text/css">
			body { text-align: center; }
			##container {
				width: 80%;
				margin: auto;
				text-align: left;
			}
			p, ul {
				font-family: verdana,sans-serif;
				font-size: 0.75em;
			}
			li { margin-bottom: 10px; }
			.navLink {
				margin: 10px;
				padding: 5px 10px;
				background-color: ##ccc;
				color: ##000;
				text-decoration: none;
				border: 3px outset ##ccc;
			}
		</style>
		<div id="container">
		<p>Welcome to the demo app for Barney's TreeManager component.  It's a simple
		little component that will manage an in-database tree for you using the
		nested set model.
		</p>
		<p>In order to run the demo, you'll need to configure a datasource and record
		it's name at the top of this file.  The datasource must have CREATE TABLE
		privileges so that the demo can install itself.  It will use a single table
		named 'treedemo' (unless you change that as well at the top of the file).
		</p>
		<p>Once that's taken care of, hit the 'install' link below, and you'll be
		on your way.  It will create the table, inject a series of rows, and then
		build a tree out of them.  If you've already installed, you can jump direct
		to the view page as well.
		</p>
		
		<p style="text-align:center;">
		<a href="#listLast(cgi.script_name, "/")#?do=install" class="navLink">Install</a>
		<a href="#listLast(cgi.script_name, "/")#?do=view" class="navLink">View</a>
		</p>
		
		<p>Couple footnotes:
		</p>
		<ul>
			<li>The SQL has only been tested on MySQL 4.1.x.  I don't think it'll
			work on anything else, aside from newer versions of MySQL.  Porting it
			should be quite trivial.  There are five uses of the LIMIT clause, which
			is roughly the equiv of MS SQL Server's TOP clause.  Switch those out,
			and it's quite possible the rest will be fine.  If you do that, please
			send me the code so I can patch it in and rerelease it.
			</li>
			<li>I've only tested on CFMX 6.1.  I see no reason that it wouldn't work
			on CF 7, but no guarentees.  Again, please let me know if you find issues
			and what the fixes are, so I can patch the public version.
			</li>
			<li>Complete docs for the component can be found in HTML form in
			<a href="treemanager.html">treemanager.html</a>, or you can hit the
			<a href="treemanager.cfc">treemanager.cfc</a> component itself, which
			should forward you to the CFCExplorer thiny built into CFMX.  The former
			is nicer.
			</li>
			<li>The nested set model theoretically allows for multiple root nodes, but
			this implementation doesn't.  Certain parts will work with trees containing
			multiple root nodes, but other parts won't.  The parts that do work are
			purely by chance, and not by design.
			</li>
		</ul>
		</div>
		</cfoutput>
	</cfdefaultcase>

</cfswitch>

